class LOOP
{
    public:
       virtual void exec() = 0;       
};

class LoopA : public LOOP
{
    public:
        unsigned long inx;
        unsigned long index;
    
    
        LoopA()
        {
            inx=0;
            index=0;
        }
    
        void exec()
        {
            adw.aktualisieren();
            setzeMotor(   2*(-300-(adw.holeWert()-608))   );
            
            if(inx%100==0)
               index++;
                                    
            inx++;
            
            if(index>=MAXARR)
            {
                inx=0;
                index=0;
                ZUSTAND=1;
            }
        }
} loopA;

class LoopB : public LOOP
{
    public:
        unsigned long index,inx;
        
        LoopB()
        {
             index=0;
             inx=0;
        }
        
        void exec()
        {
            adw.aktualisieren();
            setzeMotor(   2*(0-(adw.holeWert()-608))   );
            if(inx%100==0) //20000Hz, %100 => 200Hz
            {
                arr[index]=(adw.holeWert()-608);            
                index++;
            }    
            inx++;
            
            if(index>=MAXARR)
            {
                index=0;
                inx=0;
                ZUSTAND=2;
                setzeMotor(0);
            }
        }
} loopB;

class LoopC : public LOOP
{
    public:    
        unsigned long index,inx;
        
        LoopC()
        {
             index=0;
             inx=0;
        }
        
        void exec()
        {
            if(inx%100==0)
            {
                Serial.print(index);
                Serial.print(" ");
                Serial.println(arr[index]);
                index++;
            }    
            
            inx++;
            
            if(index>=MAXARR)
            {
                ZUSTAND=0;
                index=0;
                inx=0;
            }             
        }
} loopC;


