
//5000Hz: Schafft D-Anteil nicht mehr:
//TEST mit 50000Hz !!!!:
//5000Hz
//#define MOTORMAX 3199
//50000Hz
//#define MOTORMAX 319
//20000Hz
#define MOTORMAX 799
#define MAXARR 200

volatile int arr[MAXARR];
volatile unsigned int ZEITSCHRITTE = 0;

int ZUSTAND=0;
//dt = 0.0002; //5000Hz == 0.0002s

void setzeMotor(long int wert) // +/- 3199
{
      if(wert>MOTORMAX)
          wert=MOTORMAX;
      if(wert<-MOTORMAX)    
          wert=-MOTORMAX;
          
      if(wert>0)    
      {
          digitalWrite(7,1);
          digitalWrite(8,0);
//          analogWrite(9,wert);
          OCR1A = wert;
      }    
      else if(wert<0)
      {
          digitalWrite(7,0);
          digitalWrite(8,1);
//          analogWrite(9,-wert);
          OCR1A = -wert;
      }
      else
      {
          digitalWrite(7,0);
          digitalWrite(8,0);
//          analogWrite(9,0);
          OCR1A = 0;
      }
}

#include "MODULE.h"
#include "LOOP.h"
LOOP* loops[3] = {&loopA,&loopB,&loopC};

void setup() 
{    
    pinMode(12,INPUT); //Taster
    digitalWrite(12,1);

    pinMode(11,OUTPUT); //Lautsprecher

    pinMode(7, OUTPUT); 
    pinMode(8, OUTPUT); 
    digitalWrite(7,0);
    digitalWrite(8,0);
    Serial.begin(9600);
    
    adw.start();
    timer1.start();
        
}

ISR(TIMER1_COMPA_vect)  //Ein Durchgang
{
    loops[ZUSTAND]->exec();
  
    if(ZEITSCHRITTE%10==0)
        digitalWrite(11,1);
    if(ZEITSCHRITTE%10==5)
        digitalWrite(11,0);

    pinMode(12,INPUT); //Taster
    digitalWrite(12,1);

    
    ZEITSCHRITTE++;
    ZEITSCHRITTE%=500;  //0..499 == 0.01 Sekunde
    //theoretisch überflüssig, da an Timer 1 Overflow gekoppelt.
}

void loop() 
{
    //leer, alles passiert zeitlich getaktet in der ISR (Interrupt Service Routine)
}
